import React from 'react';
import { Helmet } from 'react-helmet';
import { renderRoutes } from 'react-router-config';
import { BrowserRouter as Router, Switch } from 'react-router-dom';
import { connect } from 'react-redux';
import config from '../../routes/config';
import Authozed from '@/utils/authority';
import UserLogin from '@/pages/user/login';
import UserLayout from '@/layouts/UserLayout';
import { AUTHORITY, BASENAME } from '@/utils/constants';
export default connect(store => ({
  auth: store,
}))(function App() {
  console.log('reRender');
  return (
    <>
      <Helmet titleTemplate="%s - 运维平台" defaultTitle="运维平台">
        <meta name="description" content="运维平台" />
      </Helmet>
      <Authozed
        noMatch={
          <UserLayout>
            <UserLogin />
          </UserLayout>
        }
        authority={[AUTHORITY.LOGIN]}
      >
        <Router basename={BASENAME}>
          <Switch>{renderRoutes(config.routes)}</Switch>
        </Router>
      </Authozed>
    </>
  );
});
