import React, { useState, useEffect } from 'react';
import { Form, Select, Input, Button, Row, Col, Radio } from 'antd';
import { editWebsite, getWebsite } from '@/services/mobileConfig/api';

const { Item } = Form;
const { Option } = Select;
const SiteConfig = props => {
  const [config, setConfig] = useState(''); // 网站配置信息
  const [loginList, setLoginList] = useState([
    { text: '默认界面', value: 'default' },
  ]); // 系统登陆页
  const [styleList, setStyleList] = useState([
    { text: '默认风格', value: 'default' },
  ]); // 系统风格
  const [themeList, setThemeList] = useState([
    { text: '默认皮肤', value: 'default' },
  ]); // 系统皮肤

  const [form] = Form.useForm();
  const layout = {
    layout: 'horizontal',
    labelCol: { span: 3 },
    wrapperCol: { span: 14 },
  };
  useEffect(() => {
    getWebsite({
      _version: 9999,
      _dc: Date.now(),
      title: '新运维测试小程序',
    }).then(res => {
      console.log(res);
      let obj = { ...form.getFieldsValue() };
      let arr = Object.keys({ ...form.getFieldsValue() });
      console.log(arr);
      arr.map(k => {
        obj[k] = res[k];
      });
      form.setFieldsValue(obj);
    });
  }, []);
  // 单选值改变
  const radioChange = e => {};
  // 提交选择
  const submit = value => {
    console.log(form.getFieldsValue());
  };
  return (
    <Form form={form} {...layout}>
      <Item label="应用名称：" name="title">
        <Input placeholder="请输入应用名称" allowClear />
      </Item>

      <Item label="系统图标：" name="shortcutIcon">
        <Input placeholder="请输入系统图标名称" allowClear />
      </Item>

      {/* <Button type="primary">按路径选择</Button> */}

      <Item label="系统图标预览：" />
      <Item label="登陆页面：" name="loginTemplate">
        <Select placeholder="请选择登陆页面">
          {loginList &&
            loginList.map((item, index) => (
              <Option value={item.value} key={`item${index}`}>
                {item.text}
              </Option>
            ))}
        </Select>
      </Item>
      <Item label="系统皮肤：" name="theme">
        <Select placeholder="请选择系统皮肤">
          {themeList &&
            themeList.map((item, index) => (
              <Option value={item.value} key={`item${index}`}>
                {item.text}
              </Option>
            ))}
        </Select>
      </Item>
      <Item label="系统风格：" name="style">
        <Select placeholder="请选择系统风格">
          {styleList &&
            styleList.map((item, index) => (
              <Option value={item.value} key={`item${index}`}>
                {item.text}
              </Option>
            ))}
        </Select>
      </Item>
      <Item label="开启云登陆：" name="cloudLogin">
        <Radio.Group onChange={radioChange} defaultValue={false}>
          <Radio value>是</Radio>
          <Radio value={false}>否</Radio>
        </Radio.Group>
      </Item>
      <Item style={{ textAlign: 'center' }}>
        <Button type="primary" onClick={submit}>
          提交
        </Button>
      </Item>
    </Form>
  );
};
export default SiteConfig;
