import React, { useState, useEffect } from 'react';
import { Card, Tabs } from 'antd';
import { PageContainer } from '@ant-design/pro-layout';
import { miniAppSiteTree } from '@/services/mobileConfig/api';
import SiteConfig from './SiteConfig';
const { TabPane } = Tabs;
const MobileConfigPage = props => {
  const [activeKey, setActiveKey] = useState('0'); // tabs活动页
  useEffect(() => {
    miniAppSiteTree({
      userMode: 'admin',
      select: '',
      _version: 9999,
      _dc: new Date().getTime(),
      node: -2,
    }).then(res => {
      console.log(res);
    });
  }, []);
  // 修改选中的tab
  const handleChange = key => {
    setActiveKey(key);
  };
  return (
    <PageContainer>
      <Card>
        <Tabs activeKey={activeKey} type="card" onChange={handleChange}>
          <TabPane tab="网站配置" key="0">
            <SiteConfig />
          </TabPane>
          <TabPane tab="菜单管理" key="1">
            <div>菜单管理</div>
          </TabPane>
        </Tabs>
      </Card>
    </PageContainer>
  );
};

export default MobileConfigPage;
