import React from 'react';
import { Button, Drawer } from 'antd';
import styles from './siteConfigDrawer.less';
import BaseForm from '@/components/BaseForm';

let form = null;

const defaultKeyMap = {
  title: {
    label: '标题',
    formType: 'input',
    allowClear: true,
    placeholder: '请输入标题',
    rules: [
      {
        required: true,
        message: '标题为必填项',
      },
    ],
  },
  subtitle: {
    label: '副标题',
    formType: 'input',
    allowClear: true,
  },
  shortcutIcon: {
    label: '图标icon',
    formType: 'image',
    rules: [
      {
        required: true,
        message: '请选择图标icon',
      },
    ],
  },
  logo: {
    label: '登录logo',
    formType: 'image',
    rules: [
      {
        required: true,
        message: '请选择登录logo',
      },
    ],
  },
  bannerlogo: {
    label: '标题logo',
    formType: 'image',
    rules: [
      {
        required: true,
        message: '请选择标题logo',
      },
    ],
  },
  client: {
    label: '虚拟目录',
    formType: 'input',
    allowClear: true,
    size: 'small',
    rules: [
      {
        required: true,
        message: '虚拟目录不能为空',
      },
    ],
  },
  homePage: {
    label: '主页',
    formType: 'input',
    allowClear: true,
  },
  loginTemplate: {
    label: '登录模板',
    formType: 'select',
    placeholder: '请选择登录模板',
    filterOption: (input, option) =>
      option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0,
    rules: [
      {
        required: true,
        message: '登录模板必填',
      },
    ],
  },
  theme: {
    label: '系统皮肤',
    formType: 'singleRadio',
    rules: [
      {
        required: true,
        message: '请选择系统皮肤',
      },
    ],
  },
  style: '系统风格',
  menu: '菜单类型',
  mode: '功能标签',
  qrcode: '二维码地址',
  mapPlan: '地图方案',
  waterMark: '地图水印',
};

export default props => {
  const { visible, onClose, config } = props;

  const getForm = f => {
    form = f;
  };
  const adaptConfig = conf => {};
  const formConfig = {
    getForm,
    items: [
      {
        label: '标题',
        dataIndex: 'title',
        initialValue: '',
        rules: [],
      },
    ],
  };
  return (
    <div className={styles.siteConfigContainer}>
      <Drawer
        title="Multi-level drawer"
        width={520}
        closable
        onClose={onClose}
        visible={visible}
      >
        <BaseForm {...formConfig} />
      </Drawer>
    </div>
  );
};
