import React, { useEffect, useState } from 'react';
import { PageContainer } from '@ant-design/pro-layout';
import { Tabs } from 'antd';
import menuTreeMock from '@/services/mocks/web4site';
import styles from './index.less';
import SiteConfig from './components/siteConfigDrawer';
const { TabPane } = Tabs;

const getMenuTree = () =>
  new Promise((r, j) => {
    setTimeout(() => {
      r(menuTreeMock);
    }, 1000);
  });

const WebConfigPage = props => {
  const [configVisible, setConfigVisible] = useState(false);
  const [loading, setLoading] = useState(false);
  const [menuTree, setMeneTree] = useState({ children: [] });
  const [configObj, setConfigObj] = useState({});
  const renderPage = () => {};

  useEffect(() => {
    getMenuTree().then(res => {
      setMeneTree(res);
      setLoading(false);
    });
  }, []);

  const renderTabPane = tabPaneItem => (
    <TabPane key={tabPaneItem.id} tab={tabPaneItem.text} />
  );

  const onEdit = (targetKey, action) => {
    // console.log(targetKey, action); // action: add|remove
    switch (action) {
      case 'add':
        setConfigVisible(true);
        break;
      case 'remove':
        break;
      default:
    }
  };

  const onDrawerClose = form => {};

  return (
    <PageContainer loading={loading}>
      <div className={styles.webConfigContainer}>
        <Tabs type="editable-card" onEdit={onEdit}>
          {menuTree.children.map(renderTabPane)}
        </Tabs>
        <SiteConfig
          visible={configVisible}
          onClose={onDrawerClose}
          config={configObj}
        />
      </div>
    </PageContainer>
  );
};

export default WebConfigPage;
